package com.yd.zalo_sign_in

import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.common.MethodChannel
import io.flutter.plugin.common.MethodChannel.MethodCallHandler
import io.flutter.plugin.common.MethodChannel.Result
import io.flutter.plugin.common.PluginRegistry.Registrar

class ZaloSignInPlugin(private val registrar: Registrar) : MethodCallHandler {

    private var zaloSignInDelegate = ZaloSignInDelegate(registrar)
    
    companion object {
        @JvmStatic
        fun registerWith(registrar: Registrar) {
            val zaloSignInPlugin = ZaloSignInPlugin(registrar)
            val channel = MethodChannel(registrar.messenger(), Constant.CHANNEL_NAME)
            channel.setMethodCallHandler(zaloSignInPlugin)
        }
    }

    override fun onMethodCall(call: MethodCall, result: Result) {

        when (call.method) {
            Constant.METHOD_LOG_IN -> {
                zaloSignInDelegate.logIn(result);
            }
            Constant.METHOD_LOG_OUT -> {
                result.notImplemented()
            }
            else -> result.notImplemented()
        }

    }

}