package com.yd.zalo_sign_in

import android.util.Log
import com.zing.zalo.zalosdk.oauth.OauthResponse

internal object ZaloLoginResults {

    fun error(errorCode: Int, message: String?): Map<String, Any> {
        return HashMap<String, Any>().apply {
            put("isSuccess", false)
            put("errorCode", errorCode)
            message?.let { put("message", it) }
        }
    }

    fun success(oauthResponse: OauthResponse?): Map<String, Any> {

        Log.d("ZaloLoginResults", oauthResponse?.oauthCode);

        return HashMap<String, Any>().apply {
            put("isSuccess", oauthResponse != null)
            put("errorCode", 0)
            oauthResponse?.oauthCode?.let { put("code", it) }
        }
    }
}