package com.yd.zalo_sign_in

import android.app.Activity
import android.content.Intent
import com.zing.zalo.zalosdk.oauth.OAuthCompleteListener
import com.zing.zalo.zalosdk.oauth.OauthResponse
import com.zing.zalo.zalosdk.oauth.ZaloSDK
import io.flutter.plugin.common.MethodChannel
import io.flutter.plugin.common.PluginRegistry

class ZaloSignInResultDelegate(private val activity: Activity?) : OAuthCompleteListener(), PluginRegistry.ActivityResultListener {

    private val ERROR_LOGIN_IN_PROGRESS = "login_in_progress"

    private var pendingResult: MethodChannel.Result? = null


    fun setPendingResult(methodName: String, result: MethodChannel.Result) {
        if (pendingResult != null) {
            result.error(
                    ERROR_LOGIN_IN_PROGRESS,
                    methodName + " called while another Zalo " +
                            "login operation was in progress.",
                    null
            )
        }
        pendingResult = result
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?): Boolean {
        return ZaloSDK.Instance.onActivityResult(activity, requestCode, resultCode, data);
    }

    override fun onAuthenError(errorCode: Int, message: String?) {
        finishWithResult(ZaloLoginResults.error(errorCode, message))
    }

    override fun onGetOAuthComplete(response: OauthResponse?) {
        finishWithResult(ZaloLoginResults.success(response))
    }

    private fun finishWithResult(result: Any) {
        if (pendingResult != null) {
            pendingResult?.success(result)
            pendingResult = null
        }
    }
}
