import 'dart:async';

import 'package:flutter/material.dart';
import 'package:zalo_sign_in/zalo_sign_in.dart';
import 'package:zalo_sign_in/zalo_sign_in_result.dart';

void main() => runApp(MyApp());

class MyApp extends StatefulWidget {
  @override
  _MyAppState createState() => _MyAppState();
}

class _MyAppState extends State<MyApp> {
  ZaloSignInResult _zaloSignInResult;

  @override
  void initState() {
    super.initState();
    // initPlatformState();
  }

  Future<void> initPlatformState() async {}

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      home: Scaffold(
        appBar: AppBar(
          title: const Text('Plugin example app'),
        ),
        body: Center(
          child: Column(
            children: <Widget>[
              FlatButton(
                child: Text("Login with zalo"),
                onPressed: () async {
                  ZaloSignInResult zaloSignInResult =
                      await ZaloSignIn().signIn();

                  setState(() {
                    _zaloSignInResult = zaloSignInResult;
                  });
                },
              ),
              Text('Zalo login result: ${_zaloSignInResult?.oauthCode ?? ""}'),
              Text('Zalo login message: ${_zaloSignInResult?.message ?? ""}'),
              Text(
                  'Zalo login code: ${_zaloSignInResult?.errorCode?.toString() ?? ""}'),
            ],
          ),
        ),
      ),
    );
  }
}
