import 'dart:async';

import 'package:flutter/services.dart';
import 'package:zalo_sign_in/constant.dart';
import 'package:zalo_sign_in/zalo_sign_in_result.dart';

class ZaloSignIn {
  static const MethodChannel _channel =
      const MethodChannel(Constant.channelName);

  Future<ZaloSignInResult> signIn() async {
    try {
      final Map<dynamic, dynamic> result =
          await _channel.invokeMapMethod(Constant.methodLogIn);

      print("ZaloSignInResult ${result.toString()}");

      return ZaloSignInResult(
        isSuccess: result['isSuccess'] as bool,
        errorCode: result['errorCode'] as int,
        message: result['message'],
        oauthCode: result['code'],
      );
    } on PlatformException catch (error) {
      print(PlatformException);
      return ZaloSignInResult(
        isSuccess: false,
        message: error.toString(),
      );
    }
  }
}
